Index: uspace/drv/intctl/apic/apic.h
===================================================================
--- uspace/drv/intctl/apic/apic.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/apic/apic.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,7 +52,7 @@
 } apic_t;
 
-extern errno_t apic_add(apic_t *, apic_res_t *);
-extern errno_t apic_remove(apic_t *);
-extern errno_t apic_gone(apic_t *);
+extern int apic_add(apic_t *, apic_res_t *);
+extern int apic_remove(apic_t *);
+extern int apic_gone(apic_t *);
 
 #endif
Index: uspace/drv/intctl/apic/main.c
===================================================================
--- uspace/drv/intctl/apic/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/apic/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,9 +43,9 @@
 #define NAME  "apic"
 
-static errno_t apic_dev_add(ddf_dev_t *dev);
-static errno_t apic_dev_remove(ddf_dev_t *dev);
-static errno_t apic_dev_gone(ddf_dev_t *dev);
-static errno_t apic_fun_online(ddf_fun_t *fun);
-static errno_t apic_fun_offline(ddf_fun_t *fun);
+static int apic_dev_add(ddf_dev_t *dev);
+static int apic_dev_remove(ddf_dev_t *dev);
+static int apic_dev_gone(ddf_dev_t *dev);
+static int apic_fun_online(ddf_fun_t *fun);
+static int apic_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t driver_ops = {
@@ -62,9 +62,9 @@
 };
 
-static errno_t apic_get_res(ddf_dev_t *dev, apic_res_t *res)
+static int apic_get_res(ddf_dev_t *dev, apic_res_t *res)
 {
 	async_sess_t *parent_sess;
 	hw_res_list_parsed_t hw_res;
-	errno_t rc;
+	int rc;
 
 	parent_sess = ddf_dev_parent_sess_get(dev);
@@ -90,9 +90,9 @@
 }
 
-static errno_t apic_dev_add(ddf_dev_t *dev)
+static int apic_dev_add(ddf_dev_t *dev)
 {
 	apic_t *apic;
 	apic_res_t apic_res;
-	errno_t rc;
+	int rc;
 
         ddf_msg(LVL_DEBUG, "apic_dev_add(%p)", dev);
@@ -114,5 +114,5 @@
 }
 
-static errno_t apic_dev_remove(ddf_dev_t *dev)
+static int apic_dev_remove(ddf_dev_t *dev)
 {
         apic_t *apic = (apic_t *)ddf_dev_data_get(dev);
@@ -123,5 +123,5 @@
 }
 
-static errno_t apic_dev_gone(ddf_dev_t *dev)
+static int apic_dev_gone(ddf_dev_t *dev)
 {
         apic_t *apic = (apic_t *)ddf_dev_data_get(dev);
@@ -132,5 +132,5 @@
 }
 
-static errno_t apic_fun_online(ddf_fun_t *fun)
+static int apic_fun_online(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "apic_fun_online()");
@@ -138,5 +138,5 @@
 }
 
-static errno_t apic_fun_offline(ddf_fun_t *fun)
+static int apic_fun_offline(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "apic_fun_offline()");
Index: uspace/drv/intctl/i8259/i8259.c
===================================================================
--- uspace/drv/intctl/i8259/i8259.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/i8259/i8259.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,5 +45,4 @@
 #include <stdbool.h>
 #include <errno.h>
-#include <str_error.h>
 #include <async.h>
 #include <stdio.h>
@@ -64,5 +63,5 @@
 #define PIC_MAX_IRQ  15
 
-static errno_t pic_enable_irq(i8259_t *i8259, sysarg_t irq)
+static int pic_enable_irq(i8259_t *i8259, sysarg_t irq)
 {
 	if (irq > PIC_MAX_IRQ)
@@ -136,5 +135,5 @@
 
 /** Add i8259 device. */
-errno_t i8259_add(i8259_t *i8259, i8259_res_t *res)
+int i8259_add(i8259_t *i8259, i8259_res_t *res)
 {
 	sysarg_t have_i8259;
@@ -142,5 +141,5 @@
 	ioport8_t *regs1;
 	ddf_fun_t *fun_a = NULL;
-	errno_t rc;
+	int rc;
 	
 	if ((sysinfo_get_value("i8259", &have_i8259) != EOK) || (!have_i8259)) {
@@ -171,5 +170,5 @@
 	rc = ddf_fun_bind(fun_a);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function 'a': %s", str_error(rc));
+		ddf_msg(LVL_ERROR, "Failed binding function 'a'. (%d)", rc);
 		goto error;
 	}
@@ -187,5 +186,5 @@
 
 /** Remove i8259 device */
-errno_t i8259_remove(i8259_t *i8259)
+int i8259_remove(i8259_t *i8259)
 {
 	return ENOTSUP;
@@ -193,5 +192,5 @@
 
 /** i8259 device gone */
-errno_t i8259_gone(i8259_t *i8259)
+int i8259_gone(i8259_t *i8259)
 {
 	return ENOTSUP;
Index: uspace/drv/intctl/i8259/i8259.h
===================================================================
--- uspace/drv/intctl/i8259/i8259.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/i8259/i8259.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,7 +52,7 @@
 } i8259_t;
 
-extern errno_t i8259_add(i8259_t *, i8259_res_t *);
-extern errno_t i8259_remove(i8259_t *);
-extern errno_t i8259_gone(i8259_t *);
+extern int i8259_add(i8259_t *, i8259_res_t *);
+extern int i8259_remove(i8259_t *);
+extern int i8259_gone(i8259_t *);
 
 #endif
Index: uspace/drv/intctl/i8259/main.c
===================================================================
--- uspace/drv/intctl/i8259/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/i8259/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,9 +43,9 @@
 #define NAME  "i8259"
 
-static errno_t i8259_dev_add(ddf_dev_t *dev);
-static errno_t i8259_dev_remove(ddf_dev_t *dev);
-static errno_t i8259_dev_gone(ddf_dev_t *dev);
-static errno_t i8259_fun_online(ddf_fun_t *fun);
-static errno_t i8259_fun_offline(ddf_fun_t *fun);
+static int i8259_dev_add(ddf_dev_t *dev);
+static int i8259_dev_remove(ddf_dev_t *dev);
+static int i8259_dev_gone(ddf_dev_t *dev);
+static int i8259_fun_online(ddf_fun_t *fun);
+static int i8259_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t driver_ops = {
@@ -62,9 +62,9 @@
 };
 
-static errno_t i8259_get_res(ddf_dev_t *dev, i8259_res_t *res)
+static int i8259_get_res(ddf_dev_t *dev, i8259_res_t *res)
 {
 	async_sess_t *parent_sess;
 	hw_res_list_parsed_t hw_res;
-	errno_t rc;
+	int rc;
 
 	parent_sess = ddf_dev_parent_sess_get(dev);
@@ -91,9 +91,9 @@
 }
 
-static errno_t i8259_dev_add(ddf_dev_t *dev)
+static int i8259_dev_add(ddf_dev_t *dev)
 {
 	i8259_t *i8259;
 	i8259_res_t i8259_res;
-	errno_t rc;
+	int rc;
 
         ddf_msg(LVL_DEBUG, "i8259_dev_add(%p)", dev);
@@ -115,5 +115,5 @@
 }
 
-static errno_t i8259_dev_remove(ddf_dev_t *dev)
+static int i8259_dev_remove(ddf_dev_t *dev)
 {
         i8259_t *i8259 = (i8259_t *)ddf_dev_data_get(dev);
@@ -124,5 +124,5 @@
 }
 
-static errno_t i8259_dev_gone(ddf_dev_t *dev)
+static int i8259_dev_gone(ddf_dev_t *dev)
 {
         i8259_t *i8259 = (i8259_t *)ddf_dev_data_get(dev);
@@ -133,5 +133,5 @@
 }
 
-static errno_t i8259_fun_online(ddf_fun_t *fun)
+static int i8259_fun_online(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "i8259_fun_online()");
@@ -139,5 +139,5 @@
 }
 
-static errno_t i8259_fun_offline(ddf_fun_t *fun)
+static int i8259_fun_offline(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "i8259_fun_offline()");
Index: uspace/drv/intctl/icp-ic/icp-ic.c
===================================================================
--- uspace/drv/intctl/icp-ic/icp-ic.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/icp-ic/icp-ic.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,4 @@
 #include <ddf/log.h>
 #include <errno.h>
-#include <str_error.h>
 #include <ipc/irc.h>
 #include <stdint.h>
@@ -52,5 +51,5 @@
 };
 
-static errno_t icpic_enable_irq(icpic_t *icpic, sysarg_t irq)
+static int icpic_enable_irq(icpic_t *icpic, sysarg_t irq)
 {
 	if (irq > icpic_max_irq)
@@ -112,9 +111,9 @@
 
 /** Add icp-ic device. */
-errno_t icpic_add(icpic_t *icpic, icpic_res_t *res)
+int icpic_add(icpic_t *icpic, icpic_res_t *res)
 {
 	ddf_fun_t *fun_a = NULL;
 	void *regs;
-	errno_t rc;
+	int rc;
 
 	rc = pio_enable((void *)res->base, sizeof(icpic_regs_t), &regs);
@@ -137,5 +136,5 @@
 	rc = ddf_fun_bind(fun_a);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function 'a': %s", str_error(rc));
+		ddf_msg(LVL_ERROR, "Failed binding function 'a'. (%d)", rc);
 		goto error;
 	}
@@ -153,5 +152,5 @@
 
 /** Remove icp-ic device */
-errno_t icpic_remove(icpic_t *icpic)
+int icpic_remove(icpic_t *icpic)
 {
 	return ENOTSUP;
@@ -159,5 +158,5 @@
 
 /** icp-ic device gone */
-errno_t icpic_gone(icpic_t *icpic)
+int icpic_gone(icpic_t *icpic)
 {
 	return ENOTSUP;
Index: uspace/drv/intctl/icp-ic/icp-ic.h
===================================================================
--- uspace/drv/intctl/icp-ic/icp-ic.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/icp-ic/icp-ic.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,7 +53,7 @@
 } icpic_t;
 
-extern errno_t icpic_add(icpic_t *, icpic_res_t *);
-extern errno_t icpic_remove(icpic_t *);
-extern errno_t icpic_gone(icpic_t *);
+extern int icpic_add(icpic_t *, icpic_res_t *);
+extern int icpic_remove(icpic_t *);
+extern int icpic_gone(icpic_t *);
 
 #endif
Index: uspace/drv/intctl/icp-ic/main.c
===================================================================
--- uspace/drv/intctl/icp-ic/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/icp-ic/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,9 +43,9 @@
 #define NAME  "icp-ic"
 
-static errno_t icpic_dev_add(ddf_dev_t *dev);
-static errno_t icpic_dev_remove(ddf_dev_t *dev);
-static errno_t icpic_dev_gone(ddf_dev_t *dev);
-static errno_t icpic_fun_online(ddf_fun_t *fun);
-static errno_t icpic_fun_offline(ddf_fun_t *fun);
+static int icpic_dev_add(ddf_dev_t *dev);
+static int icpic_dev_remove(ddf_dev_t *dev);
+static int icpic_dev_gone(ddf_dev_t *dev);
+static int icpic_fun_online(ddf_fun_t *fun);
+static int icpic_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t driver_ops = {
@@ -62,9 +62,9 @@
 };
 
-static errno_t icpic_get_res(ddf_dev_t *dev, icpic_res_t *res)
+static int icpic_get_res(ddf_dev_t *dev, icpic_res_t *res)
 {
 	async_sess_t *parent_sess;
 	hw_res_list_parsed_t hw_res;
-	errno_t rc;
+	int rc;
 
 	parent_sess = ddf_dev_parent_sess_get(dev);
@@ -90,9 +90,9 @@
 }
 
-static errno_t icpic_dev_add(ddf_dev_t *dev)
+static int icpic_dev_add(ddf_dev_t *dev)
 {
 	icpic_t *icpic;
 	icpic_res_t icpic_res;
-	errno_t rc;
+	int rc;
 
         ddf_msg(LVL_DEBUG, "icpic_dev_add(%p)", dev);
@@ -114,5 +114,5 @@
 }
 
-static errno_t icpic_dev_remove(ddf_dev_t *dev)
+static int icpic_dev_remove(ddf_dev_t *dev)
 {
         icpic_t *icpic = (icpic_t *)ddf_dev_data_get(dev);
@@ -123,5 +123,5 @@
 }
 
-static errno_t icpic_dev_gone(ddf_dev_t *dev)
+static int icpic_dev_gone(ddf_dev_t *dev)
 {
         icpic_t *icpic = (icpic_t *)ddf_dev_data_get(dev);
@@ -132,5 +132,5 @@
 }
 
-static errno_t icpic_fun_online(ddf_fun_t *fun)
+static int icpic_fun_online(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "icpic_fun_online()");
@@ -138,5 +138,5 @@
 }
 
-static errno_t icpic_fun_offline(ddf_fun_t *fun)
+static int icpic_fun_offline(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "icpic_fun_offline()");
Index: uspace/drv/intctl/obio/main.c
===================================================================
--- uspace/drv/intctl/obio/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/obio/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,9 +43,9 @@
 #define NAME  "obio"
 
-static errno_t obio_dev_add(ddf_dev_t *dev);
-static errno_t obio_dev_remove(ddf_dev_t *dev);
-static errno_t obio_dev_gone(ddf_dev_t *dev);
-static errno_t obio_fun_online(ddf_fun_t *fun);
-static errno_t obio_fun_offline(ddf_fun_t *fun);
+static int obio_dev_add(ddf_dev_t *dev);
+static int obio_dev_remove(ddf_dev_t *dev);
+static int obio_dev_gone(ddf_dev_t *dev);
+static int obio_fun_online(ddf_fun_t *fun);
+static int obio_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t driver_ops = {
@@ -62,9 +62,9 @@
 };
 
-static errno_t obio_get_res(ddf_dev_t *dev, obio_res_t *res)
+static int obio_get_res(ddf_dev_t *dev, obio_res_t *res)
 {
 	async_sess_t *parent_sess;
 	hw_res_list_parsed_t hw_res;
-	errno_t rc;
+	int rc;
 
 	parent_sess = ddf_dev_parent_sess_get(dev);
@@ -90,9 +90,9 @@
 }
 
-static errno_t obio_dev_add(ddf_dev_t *dev)
+static int obio_dev_add(ddf_dev_t *dev)
 {
 	obio_t *obio;
 	obio_res_t obio_res;
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "obio_dev_add(%p)", dev);
@@ -114,5 +114,5 @@
 }
 
-static errno_t obio_dev_remove(ddf_dev_t *dev)
+static int obio_dev_remove(ddf_dev_t *dev)
 {
         obio_t *obio = (obio_t *)ddf_dev_data_get(dev);
@@ -123,5 +123,5 @@
 }
 
-static errno_t obio_dev_gone(ddf_dev_t *dev)
+static int obio_dev_gone(ddf_dev_t *dev)
 {
         obio_t *obio = (obio_t *)ddf_dev_data_get(dev);
@@ -132,5 +132,5 @@
 }
 
-static errno_t obio_fun_online(ddf_fun_t *fun)
+static int obio_fun_online(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "obio_fun_online()");
@@ -138,5 +138,5 @@
 }
 
-static errno_t obio_fun_offline(ddf_fun_t *fun)
+static int obio_fun_offline(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "obio_fun_offline()");
Index: uspace/drv/intctl/obio/obio.c
===================================================================
--- uspace/drv/intctl/obio/obio.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/obio/obio.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,5 +47,4 @@
 #include <ddi.h>
 #include <errno.h>
-#include <str_error.h>
 #include <inttypes.h>
 #include <ipc/irc.h>
@@ -114,8 +113,8 @@
 
 /** Add OBIO device. */
-errno_t obio_add(obio_t *obio, obio_res_t *res)
+int obio_add(obio_t *obio, obio_res_t *res)
 {
 	ddf_fun_t *fun_a = NULL;
-	errno_t rc;
+	int rc;
 
 	rc = pio_enable((void *)res->base, OBIO_SIZE, (void **) &obio->regs);
@@ -139,5 +138,5 @@
 	rc = ddf_fun_bind(fun_a);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function 'a': %s", str_error(rc));
+		ddf_msg(LVL_ERROR, "Failed binding function 'a'. (%d)", rc);
 		goto error;
 	}
@@ -155,5 +154,5 @@
 
 /** Remove OBIO device */
-errno_t obio_remove(obio_t *obio)
+int obio_remove(obio_t *obio)
 {
 	return ENOTSUP;
@@ -161,5 +160,5 @@
 
 /** OBIO device gone */
-errno_t obio_gone(obio_t *obio)
+int obio_gone(obio_t *obio)
 {
 	return ENOTSUP;
Index: uspace/drv/intctl/obio/obio.h
===================================================================
--- uspace/drv/intctl/obio/obio.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/intctl/obio/obio.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,7 +52,7 @@
 } obio_t;
 
-extern errno_t obio_add(obio_t *, obio_res_t *);
-extern errno_t obio_remove(obio_t *);
-extern errno_t obio_gone(obio_t *);
+extern int obio_add(obio_t *, obio_res_t *);
+extern int obio_remove(obio_t *);
+extern int obio_gone(obio_t *);
 
 #endif
Index: uspace/drv/nic/ar9271/ar9271.c
===================================================================
--- uspace/drv/nic/ar9271/ar9271.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ar9271/ar9271.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,4 @@
 #include <ddf/interrupt.h>
 #include <errno.h>
-#include <str_error.h>
 #include <nic.h>
 #include <macros.h>
@@ -99,12 +98,12 @@
 
 /* Callback when new device is to be controlled by this driver. */
-static errno_t ar9271_add_device(ddf_dev_t *);
+static int ar9271_add_device(ddf_dev_t *);
 
 /* IEEE 802.11 callbacks */
-static errno_t ar9271_ieee80211_start(ieee80211_dev_t *);
-static errno_t ar9271_ieee80211_tx_handler(ieee80211_dev_t *, void *, size_t);
-static errno_t ar9271_ieee80211_set_freq(ieee80211_dev_t *, uint16_t);
-static errno_t ar9271_ieee80211_bssid_change(ieee80211_dev_t *, bool);
-static errno_t ar9271_ieee80211_key_config(ieee80211_dev_t *, ieee80211_key_config_t *,
+static int ar9271_ieee80211_start(ieee80211_dev_t *);
+static int ar9271_ieee80211_tx_handler(ieee80211_dev_t *, void *, size_t);
+static int ar9271_ieee80211_set_freq(ieee80211_dev_t *, uint16_t);
+static int ar9271_ieee80211_bssid_change(ieee80211_dev_t *, bool);
+static int ar9271_ieee80211_key_config(ieee80211_dev_t *, ieee80211_key_config_t *,
     bool);
 
@@ -128,7 +127,7 @@
 static ieee80211_iface_t ar9271_ieee80211_iface;
 
-static errno_t ar9271_get_device_info(ddf_fun_t *, nic_device_info_t *);
-static errno_t ar9271_get_cable_state(ddf_fun_t *, nic_cable_state_t *);
-static errno_t ar9271_get_operation_mode(ddf_fun_t *, int *, nic_channel_mode_t *,
+static int ar9271_get_device_info(ddf_fun_t *, nic_device_info_t *);
+static int ar9271_get_cable_state(ddf_fun_t *, nic_cable_state_t *);
+static int ar9271_get_operation_mode(ddf_fun_t *, int *, nic_channel_mode_t *,
     nic_role_t *);
 
@@ -144,5 +143,5 @@
  *
  */
-static errno_t ar9271_get_device_info(ddf_fun_t *dev, nic_device_info_t *info)
+static int ar9271_get_device_info(ddf_fun_t *dev, nic_device_info_t *info)
 {
 	assert(dev);
@@ -164,5 +163,5 @@
  *
  */
-static errno_t ar9271_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state)
+static int ar9271_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state)
 {
 	*state = NIC_CS_PLUGGED;
@@ -174,5 +173,5 @@
  *
  */
-static errno_t ar9271_get_operation_mode(ddf_fun_t *fun, int *speed,
+static int ar9271_get_operation_mode(ddf_fun_t *fun, int *speed,
     nic_channel_mode_t *duplex, nic_role_t *role)
 {
@@ -187,5 +186,5 @@
  *
  */
-static errno_t ar9271_on_multicast_mode_change(nic_t *nic,
+static int ar9271_on_multicast_mode_change(nic_t *nic,
     nic_multicast_mode_t mode, const nic_address_t *addr, size_t addr_cnt)
 {
@@ -210,5 +209,5 @@
  *
  */
-static errno_t ar9271_on_unicast_mode_change(nic_t *nic, nic_unicast_mode_t mode,
+static int ar9271_on_unicast_mode_change(nic_t *nic, nic_unicast_mode_t mode,
     const nic_address_t *addr, size_t addr_cnt)
 {
@@ -236,5 +235,5 @@
  *
  */
-static errno_t ar9271_on_broadcast_mode_change(nic_t *nic,
+static int ar9271_on_broadcast_mode_change(nic_t *nic,
     nic_broadcast_mode_t mode)
 {
@@ -258,5 +257,5 @@
 }
 
-static errno_t ar9271_data_polling(void *arg)
+static int ar9271_data_polling(void *arg)
 {
 	assert(arg);
@@ -319,5 +318,5 @@
  *
  */
-static errno_t ar9271_ieee80211_set_freq(ieee80211_dev_t *ieee80211_dev,
+static int ar9271_ieee80211_set_freq(ieee80211_dev_t *ieee80211_dev,
     uint16_t freq)
 {
@@ -330,5 +329,5 @@
 	wmi_send_command(ar9271->htc_device, WMI_STOP_RECV, NULL, 0, NULL);
 	
-	errno_t rc = hw_freq_switch(ar9271, freq);
+	int rc = hw_freq_switch(ar9271, freq);
 	if (rc != EOK) {
 		usb_log_error("Failed to HW switch frequency.\n");
@@ -352,5 +351,5 @@
 }
 
-static errno_t ar9271_ieee80211_bssid_change(ieee80211_dev_t *ieee80211_dev,
+static int ar9271_ieee80211_bssid_change(ieee80211_dev_t *ieee80211_dev,
     bool connected)
 {
@@ -401,5 +400,5 @@
 }
 
-static errno_t ar9271_ieee80211_key_config(ieee80211_dev_t *ieee80211_dev,
+static int ar9271_ieee80211_key_config(ieee80211_dev_t *ieee80211_dev,
     ieee80211_key_config_t *key_conf, bool insert)
 {
@@ -519,5 +518,5 @@
 }
 
-static errno_t ar9271_ieee80211_tx_handler(ieee80211_dev_t *ieee80211_dev,
+static int ar9271_ieee80211_tx_handler(ieee80211_dev_t *ieee80211_dev,
     void *buffer, size_t buffer_size)
 {
@@ -608,5 +607,5 @@
 }
 
-static errno_t ar9271_ieee80211_start(ieee80211_dev_t *ieee80211_dev)
+static int ar9271_ieee80211_start(ieee80211_dev_t *ieee80211_dev)
 {
 	assert(ieee80211_dev);
@@ -616,5 +615,5 @@
 	wmi_send_command(ar9271->htc_device, WMI_FLUSH_RECV, NULL, 0, NULL);
 	
-	errno_t rc = hw_reset(ar9271);
+	int rc = hw_reset(ar9271);
 	if (rc != EOK) {
 		usb_log_error("Failed to do HW reset.\n");
@@ -666,5 +665,5 @@
 }
 
-static errno_t ar9271_init(ar9271_t *ar9271, usb_device_t *usb_device)
+static int ar9271_init(ar9271_t *ar9271, usb_device_t *usb_device)
 {
 	ar9271->starting_up = true;
@@ -680,5 +679,5 @@
 	}
 	
-	errno_t rc = ath_usb_init(ar9271->ath_device, usb_device);
+	int rc = ath_usb_init(ar9271->ath_device, usb_device);
 	if (rc != EOK) {
 		free(ar9271->ath_device);
@@ -734,8 +733,8 @@
  * @param ar9271 AR9271 device structure
  *
- * @return EOK if succeed, error code otherwise
- *
- */
-static errno_t ar9271_upload_fw(ar9271_t *ar9271)
+ * @return EOK if succeed, negative error code otherwise
+ *
+ */
+static int ar9271_upload_fw(ar9271_t *ar9271)
 {
 	usb_device_t *usb_device = ar9271->usb_device;
@@ -775,5 +774,5 @@
 		memcpy(buffer, current_data, chunk_size);
 		usb_pipe_t *ctrl_pipe = usb_device_get_default_pipe(usb_device);
-		errno_t rc = usb_control_request_set(ctrl_pipe,
+		int rc = usb_control_request_set(ctrl_pipe,
 		    USB_REQUEST_TYPE_VENDOR,
 		    USB_REQUEST_RECIPIENT_DEVICE,
@@ -785,5 +784,5 @@
 			free(buffer);
 			usb_log_error("Error while uploading firmware. "
-			    "Error: %s\n", str_error_name(rc));
+			    "Error: %d\n", rc);
 			return rc;
 		}
@@ -803,5 +802,5 @@
 	*/
 	usb_pipe_t *ctrl_pipe = usb_device_get_default_pipe(usb_device);
-	errno_t rc = usb_control_request_set(ctrl_pipe,
+	int rc = usb_control_request_set(ctrl_pipe,
 	    USB_REQUEST_TYPE_VENDOR,
 	    USB_REQUEST_RECIPIENT_DEVICE,
@@ -834,8 +833,8 @@
 	/* USB framework initialization. */
 	const char *err_msg = NULL;
-	errno_t rc = usb_device_create_ddf(dev, endpoints, &err_msg);
+	int rc = usb_device_create_ddf(dev, endpoints, &err_msg);
 	if (rc != EOK) {
 		usb_log_error("Failed to create USB device: %s, "
-		    "ERR_NUM = %s\n", err_msg, str_error_name(rc));
+		    "ERR_NUM = %d\n", err_msg, rc);
 		return NULL;
 	}
@@ -854,6 +853,6 @@
 	if (rc != EOK) {
 		free(ar9271);
-		usb_log_error("Failed to initialize AR9271 structure: %s\n",
-		    str_error_name(rc));
+		usb_log_error("Failed to initialize AR9271 structure: %d\n",
+		    rc);
 		return NULL;
 	}
@@ -877,7 +876,7 @@
  * @param dev The device structure.
  *
- * @return EOK if succeed, error code otherwise
- */
-static errno_t ar9271_add_device(ddf_dev_t *dev)
+ * @return EOK if succeed, negative error code otherwise
+ */
+static int ar9271_add_device(ddf_dev_t *dev)
 {
 	assert(dev);
@@ -896,5 +895,5 @@
 	
 	/* Initialize AR9271 HTC services. */
-	errno_t rc = htc_init(ar9271->htc_device);
+	int rc = htc_init(ar9271->htc_device);
 	if (rc != EOK) {
 		ar9271_delete_dev_data(ar9271);
Index: uspace/drv/nic/ar9271/ath.h
===================================================================
--- uspace/drv/nic/ar9271/ath.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ar9271/ath.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,8 +40,8 @@
 /** Atheros wifi operations. */
 typedef struct {
-	errno_t (*send_ctrl_message)(struct ath *, void *, size_t);
-	errno_t (*read_ctrl_message)(struct ath *, void *, size_t, size_t *);
-	errno_t (*send_data_message)(struct ath *, void *, size_t);
-	errno_t (*read_data_message)(struct ath *, void *, size_t, size_t *);
+	int (*send_ctrl_message)(struct ath *, void *, size_t);
+	int (*read_ctrl_message)(struct ath *, void *, size_t, size_t *);
+	int (*send_data_message)(struct ath *, void *, size_t);
+	int (*read_data_message)(struct ath *, void *, size_t, size_t *);
 } ath_ops_t;
 
Index: uspace/drv/nic/ar9271/ath_usb.c
===================================================================
--- uspace/drv/nic/ar9271/ath_usb.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ar9271/ath_usb.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,8 +39,8 @@
 #include "ath_usb.h"
 
-static errno_t ath_usb_send_ctrl_message(ath_t *, void *, size_t);
-static errno_t ath_usb_read_ctrl_message(ath_t *, void *, size_t, size_t *);
-static errno_t ath_usb_send_data_message(ath_t *, void *, size_t);
-static errno_t ath_usb_read_data_message(ath_t *, void *, size_t, size_t *);
+static int ath_usb_send_ctrl_message(ath_t *, void *, size_t);
+static int ath_usb_read_ctrl_message(ath_t *, void *, size_t, size_t *);
+static int ath_usb_send_data_message(ath_t *, void *, size_t);
+static int ath_usb_read_data_message(ath_t *, void *, size_t, size_t *);
 
 static ath_ops_t ath_usb_ops = {
@@ -56,8 +56,8 @@
  * @param usb_device  Connected USB device.
  *
- * @return EOK if succeed, error code otherwise.
+ * @return EOK if succeed, negative error code otherwise.
  *
  */
-errno_t ath_usb_init(ath_t *ath, usb_device_t *usb_device)
+int ath_usb_init(ath_t *ath, usb_device_t *usb_device)
 {
 	ath_usb_t *ath_usb = malloc(sizeof(ath_usb_t));
@@ -91,8 +91,8 @@
  * @param buffer_size Buffer size.
  *
- * @return EOK if succeed, error code otherwise.
+ * @return EOK if succeed, negative error code otherwise.
  *
  */
-static errno_t ath_usb_send_ctrl_message(ath_t *ath, void *buffer,
+static int ath_usb_send_ctrl_message(ath_t *ath, void *buffer,
     size_t buffer_size)
 {
@@ -111,8 +111,8 @@
  * @param transferred_size Real size of read data.
  *
- * @return EOK if succeed, error code otherwise.
+ * @return EOK if succeed, negative error code otherwise.
  *
  */
-static errno_t ath_usb_read_ctrl_message(ath_t *ath, void *buffer,
+static int ath_usb_read_ctrl_message(ath_t *ath, void *buffer,
     size_t buffer_size, size_t *transferred_size)
 {
@@ -130,8 +130,8 @@
  * @param buffer_size Buffer size.
  *
- * @return EOK if succeed, error code otherwise.
+ * @return EOK if succeed, negative error code otherwise.
  *
  */
-static errno_t ath_usb_send_data_message(ath_t *ath, void *buffer,
+static int ath_usb_send_data_message(ath_t *ath, void *buffer,
     size_t buffer_size)
 {
@@ -151,5 +151,5 @@
 	    ath_usb->usb_device, ath_usb->output_data_pipe_number)->pipe;
 	
-	errno_t ret_val = usb_pipe_write(pipe, complete_buffer,
+	int ret_val = usb_pipe_write(pipe, complete_buffer,
 	    complete_buffer_size);
 	
@@ -166,8 +166,8 @@
  * @param transferred_size Real size of read data.
  *
- * @return EOK if succeed, error code otherwise.
+ * @return EOK if succeed, negative error code otherwise.
  *
  */
-static errno_t ath_usb_read_data_message(ath_t *ath, void *buffer,
+static int ath_usb_read_data_message(ath_t *ath, void *buffer,
     size_t buffer_size, size_t *transferred_size)
 {
Index: uspace/drv/nic/ar9271/ath_usb.h
===================================================================
--- uspace/drv/nic/ar9271/ath_usb.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/ar9271/ath_usb.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -59,5 +59,5 @@
 } ath_usb_data_header_t;
 
-extern errno_t ath_usb_init(ath_t *, usb_device_t *);
+extern int ath_usb_init(ath_t *, usb_device_t *);
 
 #endif  /* ATHEROS_ATH_USB_H */
